
package Interface;

import java.text.DecimalFormat;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.HBox;
import javafx.scene.layout.VBox;
import javafx.scene.shape.Circle;
import javafx.scene.shape.Line;
import javafx.scene.shape.Path;
import javafx.stage.Screen;

public interface Interface {
    
//Number values
    int INDEX_ZERO = 0;
    int INDEX_ONE = 1;
    int INDEX_TWO = 2;
    int INDEX_THREE = 3;
    int INDEX_FOUR = 4;
    int INDEX_FIVE = 5;
    int INDEX_SIX = 6;    
    double sceneWidth = Screen.getPrimary().getVisualBounds().getWidth();
    double sceneHeight = Screen.getPrimary().getVisualBounds().getHeight();    
    
//String values
    String start = "Start"; String stop = "Stop";
    String pause = "Pause"; String reset = "Reset";
    String back = "Return"; String help = "Help";
     String waves = "Waves & Modern Physics";
    
    
    String oscillation = "Simple Harmonic Motion"; String doppler = "Doppler Effect";
    String error = "error";
    
//Common variables        
    DecimalFormat df_1 = new DecimalFormat("#.#");
    DecimalFormat df_2 = new DecimalFormat("#.##");
    
//Menu Layouts final values
    BorderPane[] mainPages = {new BorderPane(),new BorderPane(),new BorderPane(),new BorderPane()};
    Button[] mainPageButtonSet = {new Button(),new Button(),new Button(),new Button()};
    
    Button[] wavesButtonSet = {new Button(),new Button()};
    
    VBox[] buttonGroup = {new VBox(),new VBox(),new VBox(),new VBox()};
    String[] labels = {null,null,null,null};    
    

    
//Simple Harmonic Motion final values
    Button startButtonWaves = new Button(start);
    Button pauseButtonWaves = new Button(pause);
    Button resetButtonWaves = new Button(reset);
    Button backButtonWaves = new Button(back);
    Button stopButtonWaves = new Button(stop);
    Button helpButtonWaves = new Button(help);
    int INIT_X = 65, INIT_Y = 350;
    int DEFAULT_AMPLITUDE = 70, DEFAULT_FREQUENCY = 2;
    double INIT_TIME = Math.PI/200;
    Circle[] waveString = new Circle[120];
    HBox buttonGroup_SHM = new HBox();
    TextField inputAmplitude_SHM = new TextField();
    TextField inputFrequency_SHM = new TextField();
    Label ampltiudeUnits = new Label("meters");
    Label frequencyUnits_SHM = new Label("Hz");
    BorderPane root_SHM = new BorderPane();
    
//Doppler Effect final values
    Button startButtonDoppler = new Button(start);
    Button pauseButtonDoppler = new Button(pause);
    Button resetButtonDoppler = new Button(reset);
    Button backButtonDoppler = new Button(back);    
    int INIT_X_Source = 400; int INIT_Y_Source = 400;
    int INIT_X_OBSERVER = 600; int INIT_Y_OBSERVER = 350;
    double fadeRate = 0.003;
    TextField inputVelocitySource = new TextField();
    TextField inputVelocityObserver = new TextField();
    TextField inputFrequency_doppler = new TextField();
    Label sourceVelocityUnits = new Label("x 10^2 m/s");
    Label observerVelocityUnits = new Label("x 10^2 m/s");
    Label frequencyUnits_doppler = new Label("kHz");
    BorderPane root_doppler = new BorderPane();
    HBox buttonGroup_doppler = new HBox();


}